/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Applications
   Method Init() constructor
   Method Find(id, applications, refdat)
   Method Get(id, application, requestor, refdat)
   /* BEGIN */
   Method QueryAll(apps)
   /* END */
endclass   

Method Init() class Applications
return self

Method Find(id, applications, refdat) class Applications
   local old := select(), obj := {}
   select 0
   use appl index appla 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(id, 10)
      do while .not. eof() .and. appl->ID = id
         aadd(applications, Application():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(id, 10)
      do while .not. eof() .and. appl->ID = id
         obj := SaveRec(obj)
         DbfLogRollback("APPL", appl->ID, refdat)
         if appl->DELETED == "N" .and. appl->INGDAT <= refdat 
            aadd(applications, Application():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return applications
   
Method Get(id, application, requestor, refdat) class Applications
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use APPL index APPL
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("APPL", appl->ID, refdat)
         application:Transfer()	
         RestRec(obj)
      else
         application:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "productChoice"
         ProductChoices():Find(id, application:productChoices, refdat)
         for n := 1 to len(application:productChoices)
            ProductChoices():Get(application:productChoices[n]:id, application:productChoices[n], "application", refdat)
         next
      endif
      if requestor != "process"
         Processes():Find(id, application:processes, refdat)
         for n := 1 to len(application:processes)
            Processes():Get(application:processes[n]:id, application:processes[n], "application", refdat)
         next
      endif
      if requestor != "useCase"
         UseCases():Find(id, application:useCases, refdat)
         for n := 1 to len(application:useCases)
            UseCases():Get(application:useCases[n]:id, application:useCases[n], "application", refdat)
         next
      endif
      if requestor != "form"
         Forms():Find(id, application:forms, refdat)
         for n := 1 to len(application:forms)
            Forms():Get(application:forms[n]:id, application:forms[n], "application", refdat)
         next
      endif
      if requestor != "class"
         Classes():Find(id, application:classes, refdat)
         for n := 1 to len(application:classes)
            Classes():Get(application:classes[n]:id, application:classes[n], "application", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return application

class Application
   data id
   data abbrevApplication
   data nameApplication
   data codeDatabaseSystem
   data productChoices
   data processes
   data useCases
   data forms
   data classes
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Application
   self:id := 0
   self:abbrevApplication := ""
   self:nameApplication := ""
   self:codeDatabaseSystem := ""
   self:productChoices := {}
   self:processes := {}
   self:useCases := {}
   self:forms := {}
   self:classes := {}
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use appl index appl
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = applications():Get(id, application():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               appl->DELETED := self:deleted
               appl->USERID := userid
               appl->TXDATE := txdate
               appl->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("APPL")
         self:id = newId
         AddRec(1)	
         appl->ID := self:id
         /* BEGIN */
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Application
local retval := .T.
   set exact on
   if self:abbrevApplication != old_rec:abbrevApplication
      retval := .F.
   endif
   if self:nameApplication != old_rec:nameApplication
      retval := .F.
   endif
   if self:codeDatabaseSystem != old_rec:codeDatabaseSystem
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Application
   self:id := appl->ID 	
   self:abbrevApplication := rtrim(appl->APP)
   self:nameApplication := rtrim(appl->APPNAME)
   self:codeDatabaseSystem := rtrim(appl->DBSYSTEM)
   self:deleted := appl->DELETED 	
   self:userid := appl->USERID 	
   self:txdate := appl->TXDATE 	
   self:txtime := appl->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Application
   appl->APP := self:abbrevApplication
   appl->APPNAME := self:nameApplication
   appl->DBSYSTEM := self:codeDatabaseSystem
   appl->DELETED := self:deleted
   appl->USERID := userid
   appl->TXDATE := txdate
   appl->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Application
   if self:abbrevApplication != old_rec:abbrevApplication
      DbfLogAdd(alias(), "APP", old_rec:id, old_rec:abbrevApplication, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameApplication != old_rec:nameApplication
      DbfLogAdd(alias(), "APPNAME", old_rec:id, old_rec:nameApplication, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeDatabaseSystem != old_rec:codeDatabaseSystem
      DbfLogAdd(alias(), "DBSYSTEM", old_rec:id, old_rec:codeDatabaseSystem, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method QueryAll(apps) class Applications
   local old := select()
   select 0
   use appl
   do while .not. eof()
      aadd(apps, Application():New():Transfer()) 
      skip
   enddo
   use
   select(old)
return(apps)   
/* END */
