/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Rules
   Method Init() constructor
   Method Find(clssid, rules, refdat)
   Method Get(id, rule, requestor, refdat)
   /* BEGIN */
   /* END */
endclass   

Method Init() class Rules
return self

Method Find(clssid, rules, refdat) class Rules
   local old := select(), obj := {}
   select 0
   use rset index rseta 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(clssid, 10)
      do while .not. eof() .and. rset->CLSSID = clssid
         aadd(rules, Rule():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(clssid, 10)
      do while .not. eof() .and. rset->CLSSID = clssid
         obj := SaveRec(obj)
         DbfLogRollback("RSET", rset->ID, refdat)
         if rset->DELETED == "N" .and. rset->INGDAT <= refdat 
            aadd(rules, Rule():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return rules
   
Method Get(id, rule, requestor, refdat) class Rules
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use RSET index RSET
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("RSET", rset->ID, refdat)
         rule:Transfer()	
         RestRec(obj)
      else
         rule:Transfer()	
      endif
   endif
   if requestor != "old" 
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return rule

class Rule
   data id
   data descrCondition
   data descrAction
   data numberSequence
   data idClass
   data descrClass
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Rule
   self:id := 0
   self:descrCondition := ""
   self:descrAction := ""
   self:numberSequence := 0
   self:idClass := 0
   self:descrClass := ""
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use rset index rset, rseta, rsetb
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = rules():Get(id, rule():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               rset->DELETED := self:deleted
               rset->USERID := userid
               rset->TXDATE := txdate
               rset->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("RSET")
         self:id = newId
         AddRec(1)	
         rset->ID := self:id
         /* BEGIN */
         rset->CLSSID := self:class:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Rule
local retval := .T.
   set exact on
   if self:descrCondition != old_rec:descrCondition
      retval := .F.
   endif
   if self:descrAction != old_rec:descrAction
      retval := .F.
   endif
   if self:numberSequence != old_rec:numberSequence
      retval := .F.
   endif
   if self:idClass != old_rec:idClass
      retval := .F.
   endif
   if self:descrClass != old_rec:descrClass
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Rule
   self:id := rset->ID 	
   self:descrCondition := rtrim(rset->CONDITION)
   self:descrAction := rtrim(rset->ACTION)
   self:numberSequence := rset->SEQNO
   self:idClass := rset->CLSSID
   self:descrClass := rtrim(rset->LEVEL)
   self:deleted := rset->DELETED 	
   self:userid := rset->USERID 	
   self:txdate := rset->TXDATE 	
   self:txtime := rset->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Rule
   rset->CONDITION := self:descrCondition
   rset->ACTION := self:descrAction
   rset->SEQNO := self:numberSequence
   rset->CLSSID := self:idClass
   rset->LEVEL := self:descrClass
   rset->DELETED := self:deleted
   rset->USERID := userid
   rset->TXDATE := txdate
   rset->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Rule
   if self:descrCondition != old_rec:descrCondition
      DbfLogAdd(alias(), "CONDITION", old_rec:id, old_rec:descrCondition, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrAction != old_rec:descrAction
      DbfLogAdd(alias(), "ACTION", old_rec:id, old_rec:descrAction, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberSequence != old_rec:numberSequence
      DbfLogAdd(alias(), "SEQNO", old_rec:id, str(old_rec:numberSequence), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:idClass != old_rec:idClass
      DbfLogAdd(alias(), "CLSSID", old_rec:id, str(old_rec:idClass), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrClass != old_rec:descrClass
      DbfLogAdd(alias(), "LEVEL", old_rec:id, old_rec:descrClass, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
/* END */
