/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class UseCases
   Method Init() constructor
   Method Find(applid, useCases, refdat)
   Method Get(id, useCase, requestor, refdat)
   /* BEGIN */
   /* END */
endclass   

Method Init() class UseCases
return self

Method Find(applid, useCases, refdat) class UseCases
   local old := select(), obj := {}
   select 0
   use usec index useca 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(applid, 10)
      do while .not. eof() .and. usec->APPLID = applid
         aadd(useCases, UseCase():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(applid, 10)
      do while .not. eof() .and. usec->APPLID = applid
         obj := SaveRec(obj)
         DbfLogRollback("USEC", usec->ID, refdat)
         if usec->DELETED == "N" .and. usec->INGDAT <= refdat 
            aadd(useCases, UseCase():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return useCases
   
Method Get(id, useCase, requestor, refdat) class UseCases
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use USEC index USEC
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("USEC", usec->ID, refdat)
         useCase:Transfer()	
         RestRec(obj)
      else
         useCase:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "application"
         Applications():Get(usec->APPLID, useCase:application, "useCase", refdat)
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return useCase

class UseCase
   data id
   data nameUseCase
   data descrForms
   data application
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class UseCase
   self:id := 0
   self:nameUseCase := ""
   self:descrForms := ""
   self:application := Application():New()
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use usec index usec, useca
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = useCases():Get(id, useCase():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               usec->DELETED := self:deleted
               usec->USERID := userid
               usec->TXDATE := txdate
               usec->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("USEC")
         self:id = newId
         AddRec(1)	
         usec->ID := self:id
         /* BEGIN */
      usec->APPLID := self:application:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class UseCase
local retval := .T.
   set exact on
   if self:nameUseCase != old_rec:nameUseCase
      retval := .F.
   endif
   if self:descrForms != old_rec:descrForms
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class UseCase
   self:id := usec->ID 	
   self:nameUseCase := rtrim(usec->UCNAME)
   self:descrForms := rtrim(usec->UCFORMS)
   self:deleted := usec->DELETED 	
   self:userid := usec->USERID 	
   self:txdate := usec->TXDATE 	
   self:txtime := usec->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class UseCase
   usec->UCNAME := self:nameUseCase
   usec->UCFORMS := self:descrForms
   usec->DELETED := self:deleted
   usec->USERID := userid
   usec->TXDATE := txdate
   usec->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class UseCase
   if self:nameUseCase != old_rec:nameUseCase
      DbfLogAdd(alias(), "UCNAME", old_rec:id, old_rec:nameUseCase, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrForms != old_rec:descrForms
      DbfLogAdd(alias(), "UCFORMS", old_rec:id, old_rec:descrForms, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
/* END */
