/*
   Q/A's
   
   product choices
   Q What do I have to do to make a new choicelist working?
   A adjust apprefdata.ch (add new define), refdata.prg (add new list in loop) and 
     the main function (expand array dimension twice)
   
   code generation for object 
   Q Why is sees 'if requestor != ""' where I expected 'if requestor != "usecase"'? 
   A The objectname is case sensitive, probably the objectname is useCase and not usecase.
     Note an objectname always starts with a lower case character.
*/


/*
 HMGGEN - Harbour Application Generator source code

 Copyright 2014 Frank Alleman <f.alleman@chello.nl>

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 HMG library code into it.

 Parts of this project are based upon:

	HMG - Harbour Windows GUI library source code
	Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
	http://sites.google.com/site/hmgweb/

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

*/

#include "hmg.ch"

declare window HGA110
declare window HGR110
declare window HGP110
declare window HGU110
declare window HGF110
declare window HGO110
declare window HGO210
declare window HGB110
declare window HGS110

Function main()
   public aCodes := {}, app := "", nApplid := 1, userprofile, language := 2, logging := 1, nPseudoId := -1, aPseudoId := {}, ;
   application, process, activityDefinition, nextActivity, rule, form, class, user
   set scoreboard off
   set deleted on
   set date format to "dd-mm-yyyy"
   set epoch to 1920
   set wrap on
   set exclusive off
   set confirm on
   setcancel(.F.)
   // for index cloga
   external descend
   // comment out altd(0) for debugging with altd
   altd(1)
   userprofile := User():New()
   userprofile:userid := "SYS"
   load window HG0000
   HG0000.Width := GetDesktopWidth()
   HG0000.Height := GetDesktopHeight()
   HG0000.Grid_1_1.Width := 250
   HG0000.Grid_1_1.Height := GetDesktopHeight() - 68 - 61
   HG0000.Grid_1_2.Width := GetDesktopWidth() - 250
   HG0000.Grid_1_2.Height := 400 
   HG0000.Grid_1_3.Width := GetDesktopWidth() - 250
   HG0000.Grid_1_3.Height := GetDesktopHeight() - 68 - 61 - 400 
   HG0000.Grid_2_1.Width := 250
   HG0000.Grid_2_1.Height := GetDesktopHeight() - 68 - 61
   HG0000.Grid_2_2.Width := GetDesktopWidth() - 250
   HG0000.Grid_2_2.Height := 400 
   HG0000.Grid_2_3.Width := GetDesktopWidth() - 250
   HG0000.Grid_2_3.Height := GetDesktopHeight() - 68 - 64 - 400 
 	HG0000.Maximize()
	HG0000.Activate()
Return

function HG0000_OnInit()
   LoadRefdata(nApplid)
   UpdateAllViews()
return(nil)

function UpdateAllViews()
   application := Applications():Get(nApplid, Application():New(), "")
   /* tab 1 */
   HG0000.grid_1_1.DeleteAllItems
   HG0000.grid_1_2.DeleteAllItems
   HG0000.grid_1_3.DeleteAllItems
   for n := 1 to len(application:processes)
      HG0000.grid_1_1.AddItem({application:processes[n]:nameProcess, application:processes[n]:id})
   next
   if len(application:processes) > 0
      HG0000.grid_1_1.value := 1
      HG0000_activities_Update(application:processes[1])
   endif
   /* tab 2 */
   HG0000.grid_2_1.DeleteAllItems
   HG0000.grid_2_2.DeleteAllItems
   HG0000.grid_2_3.DeleteAllItems
   for n := 1 to len(application:classes)
      HG0000.grid_2_1.AddItem({application:classes[n]:nameClass, application:classes[n]:id})
   next
   if len(application:classes) > 0
      HG0000.grid_2_1.value := 1
      HG0000_properties_Update(application:classes[1])
      HG0000_rules_Update(application:classes[1])
   endif
return(nil)

function OnOpenApps()
   if Iswindowdefined(HGA110)
      HGA110.Release()
   endif
   load window HGA110
   HGA110.Activate()
return(nil)

function OnGenerateForms()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   load window HGA210
	HGA210.Activate()
return(nil)

function OnGenerateObjects()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   load window HGA220
	HGA220.Activate()
return(nil)

function OnChoiceLists()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   if Iswindowdefined(HGR110)
      HGR110.Release()
   endif
   load window HGR110
	HGR110.Activate()
return(nil)

function OnProcesses()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   if Iswindowdefined(HGP110)
      HGP110.Release()
   endif
   load window HGP110
	HGP110.Activate()
return(nil)

function OnForms()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   if Iswindowdefined(HGF110)
      HGF110.Release()
   endif
   load window HGF110
	HGF110.Activate()
return(nil)

function OnUseCases()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   if Iswindowdefined(HGU110)
      HGU110.Release()
   endif
   load window HGU110
	HGU110.Activate()
return(nil)

function OnObjects()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   if Iswindowdefined(HGO110)
      HGO110.Release()
   endif
   load window HGO110
	HGO110.Activate()
return(nil)

function OnRules()
   if empty(app)
     MsgInfo("Please select an app first")
     return(nil)
   endif  
   if Iswindowdefined(HGO210)
      HGO210.Release()
   endif
   load window HGO210
	HGO210.Activate()
return(nil)

function OnUsers()
   if Iswindowdefined(HGB110)
      HGB110.Release()
   endif
   load window HGB110
	HGB110.Activate()
return(nil)

function OnSettings()
   if Iswindowdefined(HGS110)
      HGS110.Release()
   endif
   load window HGS110
	HGS110.Activate()
return(nil)

function OnExit()
   HG0000.Release
return(nil)   
